CGAL 6.2 - 2D Arrangements: AosTraits::CompareXNearBoundary_2 Concept Reference

CGAL 6.2 - 2D Arrangements

Loading...
Searching...
No Matches
List of all members
AosTraits::CompareXNearBoundary_2 Concept Reference
Reference Manual » Concepts » Function Object Concepts

## Definition

Refines
  `AdaptableTernaryFunction`

Has models
  `AosOpenBoundaryTraits_2::Compare_x_near_boundary_`

## Operations
A model of this concept must provide:
Comparison_result | operator() (const AosTraits::X_monotone_curve_2 &xcv1, const AosTraits::X_monotone_curve_2 &xcv2, CGAL::Arr_curve_end ce)
| Given two \(x\)-monotone curves `xcv1` and `xcv2` and an enumeration `ce` that specifies either the minimum ends or the maximum ends of the curves where the curves have a vertical asymptote, compares the \(x\)-coordinate of the curves near their respective ends.

## Member Function Documentation

## ◆ operator()()

Comparison_result AosTraits::CompareXNearBoundary_2::operator() | ( | const AosTraits::X_monotone_curve_2 & | xcv1,
|  | const AosTraits::X_monotone_curve_2 & | xcv2,
|  | CGAL::Arr_curve_end | ce
| ) |  |

Given two \(x\)-monotone curves `xcv1` and `xcv2` and an enumeration `ce` that specifies either the minimum ends or the maximum ends of the curves where the curves have a vertical asymptote, compares the \(x\)-coordinate of the curves near their respective ends.

Returns `CGAL::SMALLER`, `CGAL::EQUAL`, or `CGAL::LARGER` accordingly. More precisely, compares the \(x\)-coordinates of the horizontal projection of a point \(p\) onto `xcv1` and `xcv2`. If `xcv1` and `xcv2` approach the bottom boundary-side, \(p\) is located far to the bottom, such that the result is invariant under a translation of \(p\) farther to the bottom. If `xcv1` and `xcv2` approach the top boundary-side, \(p\) is located far to the top in a similar manner.

Precondition
  The \(x\)-coordinates of the boundary of the curves at their respective ends are equal. That is, `compare_x_on_boundary_2`(`xcv1`, `xcv2`, `ce`) = `CGAL::EQUAL`.
  `parameter_space_in_y_2`(`xcv1`, `ce`) = `parameter_space_in_y_2`(`xcv2`, `ce`).
  `parameter_space_in_y_2`(`xcv1`, `ce`) \(\neq\) `CGAL::ARR_INTERIOR`.